#!/bin/bash
source globalvar.sh

SITLIST=$1
homedir=$2
obsdir_p=${homedir}/obs/
num=0

ymd2mjd() {
        local year=$1
        local mon=$((10#$2))
        local day=$((10#$3)) 
        [ $year -lt 100 ] && year=$((year + 2000))
        if [ $mon -le 2 ]; then
                mon=$(($mon + 12))
                year=$(($year - 1))
        fi
        local mjd=$(echo $year | awk '{print $1*365.25-$1*365.25%1-679006}')
        mjd=$(echo $mjd $year $mon $day | awk '{print $1+int(30.6001*($3+1))+2-int($2/100)+int($2/400)+$4}')
        echo $mjd
}
mjd2ydoy() {
        local mjd=$1
        local year=$((($mjd + 678940) / 365))
        local mjd0=$(ymd2mjd $year 1 1)
        local doy=$(($mjd - $mjd0))
        while [ $doy -le 0 ]; do
                year=$(($year - 1))
                mjd0=$(ymd2mjd $year 1 1)
                doy=$(($mjd - $mjd0 + 1))
        done
        printf "%d %03d\n" $year $doy
}
download_brdm(){
        local year=$1
        local doy=$2 

	if [ ! -f ${brdmdir}/brdm${doy}0.${yy}p ];then
                sshpass -p 'Kpl@leilei!!' scp -P 10086 zhoulei01@119.96.188.188:/usr/dev/p1/daily/${year}/${doy}/nav/brdm* ${brdmdir}
        fi
	if [ ! -f ${brdmdir}/brdm${doy}0.${yy}p ];then
		echo "${brdmdir}/brdm${doy}0.${yy}p download FAILED!"
		exit
	fi
}
copy_obs(){
        year=${1}
        yy=${year:2:2}
        doy=${2}
        obsdir1=${3}   #数据缓存目录  
        sitn=${4}
        echo "copy obs: ${rootdir}/cache/obspost/${year}/${doy}/${sitn}${doy}0.${yy}o"
        if [ ! -f ${rootdir}/cache/obspost/${year}/${doy}/${sitn}${doy}0.${yy}o ];then
                echo "post obs not exsist: ${rootdir}/cache/obspost/${year}/${doy}/${sitn}${doy}0.${yy}o"
                exit 1
        fi
        cp ${rootdir}/cache/obspost/${year}/${doy}/${sitn}${doy}0.${yy}o ${homedir}/obs/${year}/${doy}/
}

if [ -f $SITLIST ];then 
        end_sitn=''  #保留最后一个下载的 
        obsdir1=''   
        flag=0      #判断是否删除最后一个数据
        while read line
        do 
	        if [ ${num} -ge 0 ];then
                        sitn_low=$(echo $line | tr  '[A-Z]' '[a-z]')  
                        sitn=`echo $sitn_low | awk -F " " '{print $13}'` #三个基准站
                        #按照结束时间读取YMD
                        s_iyear=`echo $sitn_low | awk -F " " '{print $1}'`
                        s_imonth=`echo $sitn_low | awk -F " " '{print $2}'`
                        s_iday=`echo $sitn_low | awk -F " " '{print $3}'`
                        s_ihour=`echo $sitn_low | awk -F " " '{print $4}'`
                        s_iminute=`echo $sitn_low | awk -F " " '{print $5}'`
                        s_isec=`echo $sitn_low | awk -F " " '{print $6}'`
                        e_iyear=`echo $sitn_low | awk -F " " '{print $7}'`
                        e_imonth=`echo $sitn_low | awk -F " " '{print $8}'`
                        e_iday=`echo $sitn_low | awk -F " " '{print $9}'`
                        e_ihour=`echo $sitn_low | awk -F " " '{print $10}'`
                        e_iminute=`echo $sitn_low | awk -F " " '{print $11}'`
                        e_isec=`echo $sitn_low | awk -F " " '{print $12}'`
                        starttime="$s_iyear $s_imonth $s_iday $s_ihour $s_iminute $s_isec"
                        endtime="$e_iyear $e_imonth $e_iday $e_ihour $e_iminute $e_isec"  #$OUTTYPY是类型输出位置
                        
                        #开始时间
                        YMD1=${s_iyear}'-'${s_imonth}'-'${s_iday}   #解码需要用到的时间
                        mjd1=$(ymd2mjd $s_iyear $s_imonth $s_iday)
                        YDOY1=($(mjd2ydoy $mjd1))   
                        doy1=${YDOY1[1]}      #下载数据、路径需要
                        if [ ! -d "$obsdir_p/$s_iyear/$doy1" ];then
                                mkdir "$obsdir_p/$s_iyear/$doy1" -p
                        fi
                        #结束时间
                        YMD2=${e_iyear}'-'${e_imonth}'-'${e_iday}   #解码需要用到的时间
                        mjd2=$(ymd2mjd $e_iyear $e_imonth $e_iday)
                        YDOY2=($(mjd2ydoy $mjd2))   
                        doy2=${YDOY2[1]}      #下载数据、路径需要
                        if [ ! -d "$obsdir_p/$e_iyear/$doy2" ];then
                                mkdir "$obsdir_p/$e_iyear/$doy2" -p        #如果是同一天就创建同一个目录两次
                        fi

                        if [ ${s_iday} -eq ${e_iday} ];then
                                obsdir1=$obsdir/$s_iyear/$doy1
                                copy_obs ${s_iyear} ${doy1} ${obsdir1} ${sitn}
                                download_brdm ${s_iyear} ${doy1}
                        fi
                        if [ ${s_iday} -ne ${e_iday} ];then
                                obsdir1=${obsdir}/${s_iyear}/${doy1}
                                obsdir2=${obsdir}/${e_iyear}/${doy2}
                                copy_obs ${s_iyear} ${doy1} ${obsdir1} ${sitn}
                                download_brdm ${s_iyear} ${doy1}
                                copy_obs ${s_iyear} ${doy2} ${obsdir2} ${sitn}
                                download_brdm ${s_iyear} ${doy2}
                        fi

                fi     
                let num=num+1
        done < ${SITLIST}
        
fi