#!/usr/bin/python2.7
'''
Created on 2018/6/3

@author: jtao
'''
import getopt
import sys
import os
import math
import datetime
from shutil import copyfile
def modified_julday(iyear,imonth,iday):
    doy_of_month = [0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334]
    if  iyear < 0 or imonth < 0 or iday < 0 or imonth > 12 or iday > 366 \
            or (imonth != 0 and iday > 31) :
        print "***ERROR(modified_julday): incorrect arguments!%d %d %d\n"%(iyear, imonth, iday)
        return -1
    iyr = iyear
    if imonth <= 2:
        iyr -= 1
    result = 365 * iyear - 678941 + iyr / 4 - iyr / 100 + iyr / 400 + iday
    if imonth != 0:
        result = result + doy_of_month[imonth - 1]
    return result
def mjd2doy(jd):
    iyear = (jd + 678940) / 365;
    idoy = jd - modified_julday(iyear, 1, 1);
    while (idoy <= 0):
        iyear = iyear - 1;
        idoy = jd - modified_julday(iyear, 1, 1) + 1;
    return [iyear,idoy];
def chksit(ifile,sitlist,ofile):
    try:
        if len(ifile) > 0:
            fid_r = open(ifile,"r")
        fid_w = open(ofile,"w")
        fid_l = open(sitlist,"r")
        fid_w.write("+GNSS station\n")
        fid_w.write("*SITE GNSS         X             Y             Z        VX       VY       VZ       AX       AY       AZ     PD_XYZ\n")
    except:
        print "can't open file to read,ifile = %s,ofile = %s,sitlist = %s"%(ifile,ofile,sitlist)
        sys.exit()
    year = datetime.datetime.now().year
    month = datetime.datetime.now().month
    day = datetime.datetime.now().day
    mjd = modified_julday(year,month,day)
    [year,doy] = mjd2doy(mjd)
    for line in fid_l:
        value = line.split()
        if len(value) < 1:
            continue
        for i in xrange(len(value)):
            nline = 0
            if len(ifile) > 0:
                fid_r.seek(0)
                for xline in fid_r: 
                    if (-1 != xline.find("%s_"%(value[i][0:4].upper()))):
                        fid_w.write(xline)
                        nline = nline + 1;
                        if nline >= 3:
                            break;
            if nline < 3:
                print "sit = %s,file = %s,no record in old sit file"%(value[i][0:4],ifile)
                ## not found so we create a empty record
                fid_w.write(" %4s_POS%14.4lf%14.4lf%14.4lf%9.4lf%9.4lf%9.4lf%9.4lf%9.4lf%9.4lf%9.4lf%9.4lf%9.4lf\r\n"%(value[i][0:4].upper(),0.0,0.0,0.0,\
                                                                                                                       0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0))
                fid_w.write(" %4s_SIG%14.4lf%14.4lf%14.4lf%9.4lf%9.4lf%9.4lf%9.4lf%9.4lf%9.4lf%9.4lf%9.4lf%9.4lf\r\n"%(value[i][0:4].upper(),0.05,0.05,0.05,\
                                                                                                                       0.0,0.0,0.0,0.0,0.0,0.0,0.05,0.05,0.05))
                fid_w.write(" %4s_ENU%14.4lf%14.4lf%14.4lf%7s%-20s%7s%20s%7s%11.6lf\r\n"%(value[i][0:4].upper(),0.0,0.0,0.0," ","RECTYPE UNKNOWN","","ANTNONE         NONE"," ",year + doy / 365.0))
    fid_w.write("-GNSS station\n")
    fid_w.close()
    fid_l.close()
    if len(ifile) > 0:
        fid_r.close()
    pass
def chkant(ifile,sitlist,odir,mjd):
    try:
        fid_r = open(ifile,"r")
        fid_l = open(sitlist,"r")
    except:
        print "can't open file to read,ifile = %s,ofile = %s_tmp,sitlist = %s"%(ifile,ifile,sitlist)
        sys.exit()
    [year,doy] = mjd2doy(mjd)
    if year > 2000:
        year = year - 2000;
    difant = {}
    difenu = {}
    for line in fid_l:
        value = line.split();
        if len(value) < 1:
            continue;
        for i in xrange(len(value)):
            obsfile = "%s/%s%03d0.%02do"%(odir,value[i][0:4].lower(),doy,year)
            try:
                fid = open(obsfile,"r")
            except:
                print "can't open obs file to read,sit = %s,obsfile = %s"%(value[i][0:4],obsfile)
                continue;
            for oline in fid:
                if(-1 != oline.find("ANT # / TYPE")):
                    anttype= oline[20:40]
                    anttype = anttype.strip()
                    if len(anttype) == 0:
                        print "sit = %s,no antenna record in obsfile"%(value[i][0:4].upper())
                        continue
                    if len(anttype) > 0 and len(anttype) < 20:
                        ### complete the record
                        anttype = "%sNONE"%(oline[20:36])
                        print "sit = %s,antenna is not complete,complete the antenna as %s"%(value[i][0:4].upper(),anttype)
                    fid_r.seek(0)
                    for xline in fid_r:
                        if (-1 != xline.find("%s_ENU"%value[i][0:4].upper())):
                            if(xline[85:105] != anttype):
                                print "sit = %s,got a different antenna between sit & obs,modified as obsfile"%(value[i][0:4].upper())
                                difant[value[i][0:4].upper()] = anttype;
                            break
                if(-1 != oline.find("ANTENNA: DELTA H/E/N")):
                    estr = oline[0:14];
                    nstr = oline[14:28]
                    ustr = oline[28:42]
                    if len(estr.strip()) == 0 or len(nstr.strip()) == 0 or len(ustr.strip()) == 0:
                        print "sit = %s,no enu record"%(value[i][0:4].upper())
                        continue
                    u = float(estr)
                    e = float(nstr)
                    n = float(ustr)
                    fid_r.seek(0)
                    for xline in fid_r:
                        if (-1 != xline.find("%s_ENU"%value[i][0:4].upper())):
                            xvalue = xline.split()
                            ex = float(xvalue[1])
                            nx = float(xvalue[2])
                            ux = float(xvalue[3])
                            if ex != e or nx != n or ux != u:
                                print "sit = %s,got a difference enu delta between sit & obs,modified as obsfile"%(value[i][0:4].upper())
                                difenu[value[i][0:4].upper()] = [e,n,u]
                            break
                if(-1 != oline.find("END OF HEADER")):
                    break
            fid.close()    
    ########################### anttype part #########################
    try:
        fid_w = open("%s_tmp"%(ifile),"w")
    except:
        print "can't open file to write,file = %s_tmp"%(ifile)
        sys.exit()
    fid_r.seek(0)
    for line in fid_r:
        if(line[0] != ' '):
            fid_w.write(line)
            continue
        key = line[1:5]
        if (-1 != line.find("ENU") and difant.has_key(key)):
            newline="%s%s%s"%(line[0:85],difant[key][0:20],line[105:])
            line = newline
        fid_w.write(line)
    fid_w.close()
    copyfile("%s_tmp"%ifile,ifile)
    ######################## enu part ###############################
    try:
        fid_w = open("%s_tmp"%(ifile),"w")
    except:
        print "can't open file to write,file = %s_tmp"%(ifile)
        sys.exit()
    fid_r.seek(0)
    for line in fid_r:
        if(line[0] != ' '):
            fid_w.write(line)
            continue
        key = line[1:5]
        if (-1 != line.find("ENU") and difenu.has_key(key)):
            enustr = ("%14.4lf%14.4lf%14.4lf"%(difenu[key][0],difenu[key][1],difenu[key][2]))
            newline="%s%s%s"%(line[0:9],enustr,line[51:])
            line = newline
        fid_w.write(line)
    fid_w.close()
    copyfile("%s_tmp"%ifile,ifile)
    fid_l.close()
    fid_r.close()
    ## remove last
    os.remove("%s_tmp"%ifile)
    pass
if __name__ == '__main__':
    ## make up the sitfile with old gnss.sit or obsfile
    usage = "Usage:makeSit.py -f gnss.sit -l sitlist -o out --odir obsdir --mjd modified_juldays  -h [should not use inuptfile_tmp as output,since it is used internal]"
    opts,args = getopt.getopt(sys.argv[1:], "f:l:o:h",['odir=','mjd='])
    ifile = ""
    sitlist=""
    ofile=""
    odir=""
    mjd=0
    f_xyz=""
    if len(opts) == 0:
        print usage
        sys.exit()
    for op,value in opts:
        if op == '-f':
            ifile = value
        elif op == '-l':
            sitlist = value
        elif op == "-o":
            ofile = value
        elif op == "--odir":
            odir = value
        elif op == "--mjd":
            mjd = int(value)
        elif op == "--xyz":
            f_xyz=value
        else:
            print usage
            sys.exit()
    print "got configuration,inputfile = %s,obsdir = %s,sitlist = %s,output = %s,mjd = %d"%(ifile,odir,sitlist,ofile,mjd)
    chksit(ifile,sitlist,ofile);
    if len(odir) > 0:
        chkant(ofile,sitlist,odir,mjd);
    print "ofile = %s,generate success!"%(ofile)