#!/usr/local/bin/python3
# -*- coding: UTF-8 -*-
import numpy as np
import getopt
import sys
import math as mt
from datetime import datetime


def thransform_time(time):
    Time=str(str(time[0])+str(time[1])+str(time[2])+str(time[3])+' '+str(time[5])+str(time[6])+' '+\
        str(time[8])+str(time[9])+' '+str(time[11])+str(time[12])+' '+str(time[14])+str(time[15])+' '+str(time[17])+str(time[18]))
    return Time
pass

#只需要对分钟进行15间隔的取整（开始时间是向下取整，结束时间是补全一个时段）
#id用于判断是开始时间还是结束时间（1：开始   2:结束）
def start_end_15(starttime,id):
    sminute=starttime[14]+starttime[15]
    if id==1:num=mt.floor(int(sminute)/15)  #向下取整
    if id==2:num=mt.ceil(int(sminute)/15)  #向上取整
    if (int(sminute)%15)==0 and id==2:num=num+1    #保证后面的秒也在内
    minute=num*15
    shour=starttime[11]+starttime[12]
    int_hour=int(shour)
    if minute==60:int_hour=int_hour+1;minute=0
    #print(int_hour)
    str_shour=""
    if int_hour<10:str_shour="0"+str(int_hour)
    else:str_shour=str(int_hour)
    
    if minute==0:str_minute="00"
    else:str_minute=str(minute)
    str_sec="00"
    use_time=starttime[0]+starttime[1]+starttime[2]+starttime[3]+starttime[4]\
        +starttime[5]+starttime[6]+starttime[7]+starttime[8]+starttime[9]+starttime[10]\
        +str_shour+starttime[13]+str_minute+starttime[16]+str_sec
    return use_time
pass

def calculate_sec(starttime,endtime):
    data_stime=starttime.strip('\n').split()
    data_etime=endtime.strip('\n').split()  #转换为列表
    sday=int(data_stime[2])
    shour=int(data_stime[3])
    sminute=int(data_stime[4])
    ssec=int(data_stime[5])
    eday=int(data_etime[2])
    ehour=int(data_etime[3])
    eminute=int(data_etime[4])
    esec=int(data_etime[5])
    all_sec=(eday*86400+ehour*3600+eminute*60+esec)-(sday*86400+shour*3600+sminute*60+ssec)
    return all_sec
pass
def findsamesta(Sitname,SIT):
    for i in range (len(Sitname)):
        if Sitname[i]==SIT:return 0
    return 1
#考虑删除重复测站
def updatetime(start_tt,end_tt,all_sec,rangetime):
    newtime=[]
    data_stime=start_tt.strip('\n').split()
    data_etime=end_tt.strip('\n').split()  #转换为列表
    if int(all_sec)<int(rangetime):
        end_sec=int(data_etime[3])*3600+int(data_etime[4])*60
        if int(data_stime[2])==int(data_etime[2]):
            if end_sec>=int(rangetime):
                start_sec=end_sec-int(rangetime)
            if end_sec<int(rangetime):
                day=int(data_stime[2])-1
                if day<10:data_stime[2]="0"+str(day)
                else:data_stime[2]=str(day)
                need_sec=int(rangetime)-end_sec
                start_sec=86400-need_sec
        if int(data_stime[2])!=int(data_etime[2]):
            need_sec=int(rangetime)-end_sec
            start_sec=86400-need_sec
        start_hour=int(mt.floor(start_sec/3600))
        start_minute=int((start_sec-start_hour*3600)/60)
        str_hour=''
        str_minute=''
        if start_hour<10:str_hour="0"+str(start_hour)
        else:str_hour=str(start_hour)
        if start_minute<10:str_minute="0"+str(start_minute)
        else:str_minute=str(start_minute)
        newstart=str(data_stime[0]+" "+data_stime[1]+" "+data_stime[2]+" "+str_hour+" "+str_minute+" "+"00")
        newtime.append(newstart)
        newtime.append(end_tt)
        return newtime
    else:
        newtime.append(start_tt)
        newtime.append(end_tt)
        return newtime
        
        
def readstation(inputpath,outputpath):
    data1=[]
    with open(outputpath,'w',encoding='utf-8') as writefile:
        with open(inputpath,'r',encoding='utf-8') as readfile:
            data1=[]
            for line in readfile:
                data_line=line.strip('\n').split()
                if data_line==[]:continue  #跳过空行
                if str(data_line[0][0])=='+':continue  #跳过+GNSS项
                if str(data_line[0][0])=='*':continue  #跳过*GNSS项
                if str(data_line[0][0])=='-':continue  #跳过-GNSS项
                pos=str(str(data_line[0][5])+str(data_line[0][6])+str(data_line[0][7]))
                if pos=='POS':
                    data1.append(data_line)
            readfile.close()
            sitname=[]
            for line in data1:
                SIT=str(line[0][0]+line[0][1]+line[0][2]+line[0][3])
                flag=findsamesta(sitname,SIT)
                if flag==0:continue
                if flag==1:
                    sitname.append(SIT)
                    data2=SIT+' '+line[1]+' '+line[2]+' '+line[3]+' '+'\n'  
                    writefile.write(data2)
            writefile.close()
    return data1

def readrequest(inputpath,outputpath,rangetime,sitlist):
    start_time=[]  #开始时间
    end_time=[]    #结束时间
    VRS=[]  #合并格网点

    # 读取文件数据
    with open(inputpath,'r') as readfile:
        for line in readfile:
            vrs=[]
            data_line=line.strip('\n').split()
            start_time.append(data_line[0])
            end_time.append(data_line[1])
            vrs.append(data_line[3])#L
            vrs.append(data_line[4])#B
            vrs.append(data_line[5])#H
            vrs.append(data_line[2])  #add name
            VRS.append(vrs)      
    
    # 确定请求的经纬范围，并检查每个请求记录的高程
    minlat,minlon,maxlat,maxlon=90,360,0,0   #Grid范围
    for i in range(len(VRS)):
        lon=float(VRS[i][0]);lat=float(VRS[i][1])
        # check the height of the input request
        height=float(VRS[i][2])
        if height == 0.0:
            height_fix = fixRequestHeigt(lon,lat,height,sitlist)
            VRS[i][2] = height_fix
        if minlon>lon:minlon=lon
        if minlat>lat:minlat=lat
        if maxlon<lon:maxlon=lon
        if maxlat<lat:maxlat=lat
    
    # 生成每一条请求总体的时间跨度
    ## 需要在读取的两个列表 start_time 和 end_time 中去判断，因为用户未必会按时间顺序去填写
    ## 原有代码未考虑该问题:
    # s_time=start_time[0]
    # e_time=end_time[int(len(end_time))-1]

    for i in range(len(start_time)):
        if i <= 0:
            s_time = start_time[i]
        else:
            t1_datetime = datetime.strptime(thransform_time(s_time), "%Y %m %d %H %M %S")
            t2_datetime = datetime.strptime(thransform_time(start_time[i]), "%Y %m %d %H %M %S")
            if t1_datetime > t2_datetime:
                s_time = start_time[i]
    for i in range(len(end_time)):
        if i <= 0:
            e_time = end_time[i]
        else:
            t1_datetime = datetime.strptime(thransform_time(e_time), "%Y %m %d %H %M %S")
            t2_datetime = datetime.strptime(thransform_time(end_time[i]), "%Y %m %d %H %M %S")
            if t1_datetime < t2_datetime:
                e_time = end_time[i]

    with open(outputpath,'w',encoding='utf-8') as writefile:
        writefile.write('request_information'+' ') #添加一下格网的范围（下载大气文件时按照区域下载）
        data=str('{:.8f}'.format(float(minlon)))+' '+str('{:.8f}'.format(float(minlat)))+' '+str('{:.8f}'.format(float(maxlon)))+' '+str('{:.8f}'.format(float(maxlat)))+' '+thransform_time(s_time)+' '+thransform_time(e_time) +'\n'
        writefile.write(data)
        writefile.write('grid                                start-end                               id   sec_time'+'\n')
        for i in range(len(start_time)):
            #写一个能将开始时间和结束时间取整的，15分钟间隔
            # start_tt=start_end_15(thransform_time(start_time[i]),1)
            # end_tt=start_end_15(thransform_time(end_time[i]),2)
            # Q: 为何不再对每一个请求单独输出一个起止时间?
            # A: 因为本平台服务的处理策略就是，NRTK处理服务的总体起止时间。为了方便后续不做更多的改动，只有该步骤输出的 outrequest 文件事先将请求时间调整为总体的起止时间，后续的 conf.txt 才能保持统一，覆盖掉整个请求时间段，以使得 nrtk.json 设置满足本服务平台策略
            start_tt = start_end_15(thransform_time(s_time),1)
            end_tt = start_end_15(thransform_time(e_time),2)
            #计算开始时间到结束时间的秒数
            all_sec=str(calculate_sec(start_tt,end_tt))
            #根据时长延长时段
            newtime=updatetime(start_tt,end_tt,all_sec,rangetime)#第四个参数是时段最短长度
            if int(all_sec) < int(rangetime):all_sec=str(rangetime)
            data1=str('{:.8f}'.format(float(VRS[i][0])))+' '+str('{:.8f}'.format(float(VRS[i][1])))+' '+str('{:.8f}'.format(float(VRS[i][2])))+' '+newtime[0]+' '+newtime[1]+' '+(VRS[i][3])+' '+str(all_sec)+'\n'
            #data1=str('{:.8f}'.format(float(VRS[i][0])))+' '+str('{:.8f}'.format(float(VRS[i][1])))+' '+str('{:.8f}'.format(float(VRS[i][2])))+' '+start_tt+' '+end_tt+' '+(VRS[i][3])+' '+all_sec+'\n'
            writefile.write(data1)
        writefile.close() 
    pass

def fixRequestHeigt(lon, lat, height, sitlist):
    """
    The function is used for generating a reasonable height based on the nearest station.
    """
    height_fix = 0.0

    sitnum = len(sitlist)
    if sitnum <= 0:
        return height
    
    # get the x/y/z coordinate of the input lon/lat
    xyz_input=BLH2XYZ(lat,lon,height)

    # search the nearest 3 sit
    ## [0]: the nearest one
    isitlist = [mt.nan, mt.nan, mt.nan]
    distlist = [mt.nan, mt.nan, mt.nan]
    hlist = [mt.nan, mt.nan, mt.nan]
    for isit in range(sitnum):
        blhsit_tmp = XYZ2BLH(float(sitlist[isit][1]), float(sitlist[isit][2]), float(sitlist[isit][3]))
        h_tmp = float(blhsit_tmp[2])
        # To get the reasonable distance between 2 site, we need transform the height to the input height
        xyzsit_tmp = BLH2XYZ(float(blhsit_tmp[0]), float(blhsit_tmp[1]), float(height))
        dist_tmp = mt.sqrt((float(xyz_input[0])-float(xyzsit_tmp[0]))**2 + (float(xyz_input[1])-float(xyzsit_tmp[1]))**2 + (float(xyz_input[2])-float(xyzsit_tmp[2]))**2)

        for i in range(3):
            if (mt.isnan(isitlist[i]) or mt.isnan(distlist[i]) or mt.isnan(hlist[i])) or dist_tmp < distlist[i]:
                distlist.insert(i, dist_tmp)
                isitlist.insert(i, isit)
                hlist.insert(i, h_tmp)

                distlist.pop()
                isitlist.pop()
                hlist.pop()
                break
    
    # calculate the mean height
    weighted_sum = 0.0
    weight_sum = 0.0
    for i in range(len(isitlist)):
        if mt.isnan(isitlist[i]) or mt.isnan(distlist[i]) or mt.isnan(hlist[i]):
            continue

        weight = 1.0 / distlist[i]
        weighted_sum += hlist[i] * weight
        weight_sum += weight
        pass
    if weight_sum <= 0.0:
        return height
    
    height_fix = weighted_sum / weight_sum
    return height_fix

def rad2angle(r):
    a = r * 180.0 / mt.pi
    return a

def angle2rad(a):
    r = a * mt.pi / 180.0
    return r

def XYZ2BLH(X, Y, Z):
    a = 6378137.0
    b = 6356752.31414
    f = 1 / 298.257223563
    R = mt.sqrt(X * X + Y * Y)
    B0 = mt.atan2(Z, R)
    while 1:
        N = a / mt.sqrt(1.0 - f * (2 - f) * mt.sin(B0) * mt.sin(B0))
        B_ = mt.atan2(Z + N * f * (2 - f) * mt.sin(B0), R)
        if (mt.fabs(B_ - B0) < 1.0e-7):
            break
        B0 = B_
    L_ = mt.atan2(Y, X)
    H = R / mt.cos(B_) - N
    B = rad2angle(B_)
    L = rad2angle(L_)
    return B, L, H

def BLH2XYZ(B, L, H):
    a = 6378137.0
    b = 6356752.31414
    f = 1 / 298.257223563
    B = angle2rad(B)  
    L = angle2rad(L)  
    e = mt.sqrt((a ** 2 - b ** 2) / (a ** 2)) 
    N = a / mt.sqrt(1 - e * e * mt.sin(B) * mt.sin(B)) 
    X = (N + H) * mt.cos(B) * mt.cos(L)
    Y = (N + H) * mt.cos(B) * mt.sin(L)
    Z = (N * (1 - e * e) + H) * mt.sin(B)
    return X, Y, Z 

if __name__=="__main__":
    message='命令错误'
    if len(sys.argv)<=1 :
        print(message)
        sys.exit()
    rangetime=int(sys.argv[5])
    sitlist=readstation(sys.argv[1],sys.argv[2])
    readrequest(sys.argv[3],sys.argv[4],rangetime,sitlist)
    
    
    