#!/bin/bash

source /home/kpl_ywpt_test/proj_test/globalvar.sh

SITLIST=$1 
OUTTYPE=$2
HOMEDIR=$3
obsdir_p=${HOMEDIR}/obs/
num=0
ymd2mjd() {
        local year=$1
        local mon=$((10#$2))
        local day=$((10#$3)) 
        [ $year -lt 100 ] && year=$((year + 2000))
        if [ $mon -le 2 ]; then
                mon=$(($mon + 12))
                year=$(($year - 1))
        fi
        local mjd=$(echo $year | awk '{print $1*365.25-$1*365.25%1-679006}')
        mjd=$(echo $mjd $year $mon $day | awk '{print $1+int(30.6001*($3+1))+2-int($2/100)+int($2/400)+$4}')
        echo $mjd
}
mjd2ydoy() {
        local mjd=$1
        local year=$((($mjd + 678940) / 365))
        local mjd0=$(ymd2mjd $year 1 1)
        local doy=$(($mjd - $mjd0))
        while [ $doy -le 0 ]; do
                year=$(($year - 1))
                mjd0=$(ymd2mjd $year 1 1)
                doy=$(($mjd - $mjd0 + 1))
        done
        printf "%d %03d\n" $year $doy
}
download_brdm(){
        local year=$1
        local doy=$2 

	if [ ! -f ${brdmdir}/brdm${doy}0.${yy}p ];then
                sshpass -p 'Kpl@leilei!!' scp -P 10086 zhoulei01@119.96.188.188:/usr/dev/p1/daily/${year}/${doy}/nav/brdm* ${brdmdir}
        fi
	if [ ! -f ${brdmdir}/brdm${doy}0.${yy}p ];then
		echo "${brdmdir}/brdm${doy}0.${yy}p download FAILED!"
		exit
	fi
}
download_brdm_old(){
        local year=$1
        local doy=$2 

	fbrdm="BRDM00DLR_S_${year}${doy}0000_01D_MN.rnx"
        url="${http_brdm}/${year}/brdc/${fbrdm}.gz"  #method1
        #url="${http_brdm}/${year}/$doy/${yy}p/${fbrdm}.gz"   #method2
	if [ ! -f ${brdmdir}/brdm${doy}0.${yy}p ];then
                echo "${url}"
                wget --ftp-user anonymous --ftp-password 472120783@stu.lntu.edu.cn $url -P ${brdmdir}
                #wget -N -nH -c $url -T 30 -t 5 -P ${brdmdir}

		if [ -f "${brdmdir}/${fbrdm}.gz" ];then
			gunzip ${brdmdir}/${fbrdm}.gz
		fi
		if [ -f "${brdmdir}/${fbrdm}" ];then
                	mv ${brdmdir}/${fbrdm} ${brdmdir}/brdm${doy}0.${yy}p
		fi
        fi
	if [ ! -f ${brdmdir}/brdm${doy}0.${yy}p ];then
		echo "${brdmdir}/brdm${doy}0.${yy}p download FAILED!"
		exit
	fi
}
download_obs_15(){
        YMD=${1}
        year=${2}
        yy=${year:2:2}
        doy=${3}
        starttime=${4}
        endtime=${5}
        obsdir1=${6}   #数据缓存目录  
        sitn1=${7}
        sitn2=${7}
        sitn3=${7}
        flag1=${8}
        #根据时间段确定下载数据时间(a b c d ...x 表示小时  ;00 15  30  45 表示15分钟一个时段)  如何确定需要下载数据的列表！
        #echo $starttime
        #echo ${starttime} ${endtime}
	if [ ! -f ${OUTTYPE} ];then
		touch ${OUTTYPE}
	fi
	#python3 ${bindir}/py_getdwtime_form.py ${starttime} ${endtime} ${OUTTYPE}
        ExecuteWithoutOutput "python3 ${bindir}/py_getdwtime_form.py ${starttime} ${endtime} ${OUTTYPE}"
        cmd=" ${bindir}/gfzrnx_lx -finp"   #数据拼接命令
        stationid=3
        start_sitntype='' #拼接数据按照测站开始时刻命名
        num_samesitn=0   
        end_sitn=''         
        if [ -f $OUTTYPE ];then
                while read line
                do
                        sitn_low=$(echo $line | tr  '[A-Z]' '[a-z]')  #字母都小写
                        sitntype=${sitn_low:0:3}   #具体小时分钟
                        timetype=${sitn_low:4:1}   #具体小时
                        hour=${sitn_low:6:2}       #小时
                        minute=${sitn_low:9:2}     #分钟
                        station0=${sitn1}${doy}_${sitntype}.${yy}o  #数据文件名o
                        station00=${sitn2}${doy}_${sitntype}.${yy}o
                        station000=${sitn3}${doy}_${sitntype}.${yy}o

                        station=${sitn1}${doy}${sitntype}.${yy}b  #数据文件全名
                        station1=${sitn2}${doy}${sitntype}.${yy}b  
                        station2=${sitn3}${doy}${sitntype}.${yy}b  
                        if [ $num_samesitn -eq 0 ];then
                                start_sitntype=${sitntype}
                        fi 
                        #http
                        url="${http_obs}/${year}/${doy}/${yy}d/${timetype}/${minute}/${station}"
                        urm="${http_obs}/${year}/${doy}/${yy}d/${timetype}/${minute}/${station1}"
                        urn="${http_obs}/${year}/${doy}/${yy}d/${timetype}/${minute}/${station2}"
                        #echo $ur1
                        choosestation=3
                        if [ ! -f ${obsdir1}/${station0} ];then 
                                wget ${url} -P ${obsdir1} 
                        else
                                let  choosestation=0  #add file is download 
                        fi
                        
                        
                        if [ -f ${obsdir1}/${station0} -o -f ${obsdir1}/${station} ];then
                                let choosestation=0
                        fi
                        if [ ! -f ${obsdir1}/${station} -a ! -f ${obsdir1}/${station0} ];then
                                echo "${obsdir1}/${station} is not exist!"
                                continue  
                                if [ ! -f ${obsdir1}/${station00} ];then
                                        wget ${urm} -P ${obsdir1}
                                fi
                                if [ -f ${obsdir1}/${station00} -o -f ${obsdir1}/${station1} ];then
                                        let choosestation=1
                                fi
                                if [ ! -f ${obsdir1}/${station1} -a ! -f ${obsdir1}/${station00} ];then
                                        echo "${obsdir1}/${station1} is not exist!"
                                        if [ ! -f ${obsdir1}/${station000} ];then
                                                wget ${urn} -P ${obsdir1}
                                        fi
                                        if [ -f ${obsdir1}/${station000} -o -f ${obsdir1}/${station2} ];then
                                                let choosestation=2
                                        fi
                                        if [ ! -f ${obsdir1}/${station2} -a ! -f ${obsdir1}/${station000} ];then
                                                echo "not find ${httpdir}/${doy}/${yy}d/${minute}/${timetype} station obs file!"
                                                let choosestation=3
                                        fi
                                fi 
                        fi
                        #解码
                        isrecode=0
                        #cd ${obsdir1}    #进入数据存储目录
                        cd ${bindir}
                        if [ ${choosestation} -eq 0 -a -f ${obsdir1}/${station} ];then
                                #echo "start decod!!!!!!!!!"
                                ${bindir}/decode.sh ${sitn1}${doy}${sitntype} $YMD $hour $minute "${sitn1}${doy}_${sitntype}" ${obsdir1} ${yy} 
                                let isrecode=1
                        fi
                        if [ ${choosestation} -eq 0 -a ! -f ${obsdir1}/${station} ];then
                                let isrecode=2  #add already have decomdate
                        fi
                        if [ ${choosestation} -eq 1 -a -f ${obsdir1}/${station1} ];then
                                ${bindir}/decode.sh ${sitn2}${doy}${sitntype} $YMD $hour $minute "${sitn2}${doy}_${sitntype}" ${obsdir1} ${yy} 
                                let isrecode=1
                        fi
                        if [ ${choosestation} -eq 2 -a -f ${obsdir1}/${station2} ];then
                                ${bindir}/decode.sh ${sitn3}${doy}${sitntype} $YMD $hour $minute "${sitn3}${doy}_${sitntype}" ${obsdir1} ${yy} 
                                let isrecode=1
                        fi
                        if [ ${choosestation} -eq 3 ];then
                                echo "no station obs file to decode!"
                        fi
                        
                        cd
                        cd ${obsdir1}
                        #删除二进制文件
                        if [ $isrecode -eq 1 ];then
                                rm *.${yy}b
                        fi

                        #拼接数据
                        if [ ${choosestation} -eq 0 ];then
                                cmd="$cmd $station0"
                                let stationid=0
                                end_sitn="${sitn1}${doy}_${sitntype}"
                        fi

                        if [ ${choosestation} -eq 1 ];then
                                cmd="$cmd $station00"
                                let stationid=1
                                end_sitn="${sitn2}${doy}_${sitntype}"
                        fi

                        if [ ${choosestation} -eq 2 ];then
                                cmd="$cmd $station000"
                                let stationid=2
                                end_sitn="${sitn3}${doy}_${sitntype}"
                        fi

                        if [ ${choosestation} -eq 3 ];then
                                echo "no station obs file to Splicing!"
                        fi
                        #echo ${cmd}
                        # cd 
                        # cd ${bindir}
                        let num_samesitn=num_samesitn+1
                        #存储一下最后一个下载测站的信息
                done < ${OUTTYPE}
                #数据拼接
                issplic=0
                cd ${obsdir1}
                if [ $stationid -eq 0 ];then
                        sta=$sitn1
                        let issplic=1
                fi
                if [ $stationid -eq 1 ];then
                        sta=$sitn2
                        let issplic=1
                fi
                if [ $stationid -eq 2 ];then
                        sta=$sitn3
                        let issplic=1
                fi
                if [ $stationid -eq 3 ];then
                        echo "no station is exist!"
                fi
                #路径直接改到大程序下
                if [ $issplic -eq 1 ];then
                        cmd="$cmd  -fout ${sta}${doy}0.xxo -kv"
                        #echo $cmd
                        if [ ! -f "$obsdir_p/$year/$doy/${sta}${doy}0.${yy}o" ];then
                                echo ${cmd}
                                ${cmd}  
                                #rm *.${yy}o 
                                mv *.xxo ${obsdir_p}/$year/$doy
                        fi
                        if [ -f "$obsdir_p/$year/$doy/${sta}${doy}0.${yy}o" ];then
                                echo ${cmd}
                                echo "$obsdir_p/$year/$doy/${sta}${doy}0.${yy}o Already Exists!"
                        fi
                        cd
                        #cd ${bindir}
                        cd ${obsdir_p}
                        if [ ! -f "$obsdir_p/$year/$doy/${sta}${doy}0.${yy}o" ];then
                                echo "move $obsdir_p/$year/$doy/*.xxo $obsdir_p/$year/$doy/${sta}${doy}0.${yy}o"
                                mv $obsdir_p/$year/$doy/*.xxo $obsdir_p/$year/$doy/${sta}${doy}0.${yy}o
                        else
                                echo "error"
                        fi
                        # cd
                        # cd ${bindir} 
                fi
		sta_low=$(echo $sta | tr '[A-Z]' '[a-z]')
		if [ -f "$obsdir_p/$year/$doy/${sta}${doy}0.${yy}o" ];then
			mv "$obsdir_p/$year/$doy/${sta}${doy}0.${yy}o" "$obsdir_p/$year/$doy/${sta_low}${doy}0.${yy}o"
		fi
                #删除最后一个数据
              #  cd
              #  cd ${obsdir1}
              #  if [ -f "${obsdir1}/${end_sitn}.${yy}o" -a $flag -eq 0 ];then
               #         rm "${obsdir1}/${end_sitn}.${yy}o"   #删除最后一个下载的文件
              #  fi
              #  cd
              #  cd ${bindir} 
        fi
        #echo $end_sitn  #返回最后一个下载数据
        #echo $yy
}
ExecuteWithoutOutput() {
        local cmd="$1"
        time=$(date +'%Y-%m-%d %H:%M:%S')
        $cmd >/dev/null 2>&1 
        if [ $? -eq 0 ]; then  
                return 0
                #echo "脚本实现"
        else
                echo "脚本未实现"
                return 1
        fi
}
#./download.sh /usr/dev/vdb1/zj/project1/result/usebasestation.txt /usr/dev/vdb1/zj/project1/result/outtype.txt
#download_obs_data
#:<<EOF
if [ -f $SITLIST ];then 
        end_sitn=''  #保留最后一个下载的 
        obsdir1=''   
        flag=0      #判断是否删除最后一个数据
        while read line
        do 
	        if [ ${num} -ge 0 ];then
                        sitn_low=$(echo $line | tr  '[A-Z]' '[a-z]')
			sitn_upper=$(echo $line | tr '[a-z]' '[A-Z]')  
                        sitn1=`echo $sitn_upper | awk -F " " '{print $13}'`
                        sitn2=`echo $sitn_upper | awk -F " " '{print $13}'`
                        sitn3=`echo $sitn_upper | awk -F " " '{print $13}'`  #三个基准站
                        #按照结束时间读取YMD
                        s_iyear=`echo $sitn_low | awk -F " " '{print $1}'`
                        s_imonth=`echo $sitn_low | awk -F " " '{print $2}'`
                        s_iday=`echo $sitn_low | awk -F " " '{print $3}'`
                        s_ihour=`echo $sitn_low | awk -F " " '{print $4}'`
                        s_iminute=`echo $sitn_low | awk -F " " '{print $5}'`
                        s_isec=`echo $sitn_low | awk -F " " '{print $6}'`
                        e_iyear=`echo $sitn_low | awk -F " " '{print $7}'`
                        e_imonth=`echo $sitn_low | awk -F " " '{print $8}'`
                        e_iday=`echo $sitn_low | awk -F " " '{print $9}'`
                        e_ihour=`echo $sitn_low | awk -F " " '{print $10}'`
                        e_iminute=`echo $sitn_low | awk -F " " '{print $11}'`
                        e_isec=`echo $sitn_low | awk -F " " '{print $12}'`
                        starttime="$s_iyear $s_imonth $s_iday $s_ihour $s_iminute $s_isec"
                        endtime="$e_iyear $e_imonth $e_iday $e_ihour $e_iminute $e_isec"  #$OUTTYPY是类型输出位置
                        #echo $starttime
                        #echo $starttime
                        #开始时间
                        YMD1=${s_iyear}'-'${s_imonth}'-'${s_iday}   #解码需要用到的时间
                        mjd1=$(ymd2mjd $s_iyear $s_imonth $s_iday)
                        YDOY1=($(mjd2ydoy $mjd1))   
                        doy1=${YDOY1[1]}      #下载数据、路劲需要
                        if [ ! -d "$obsdir_p/$s_iyear/$doy1" ];then
                                mkdir "$obsdir_p/$s_iyear/$doy1" -p
                        fi
                        #结束时间
                        YMD2=${e_iyear}'-'${e_imonth}'-'${e_iday}   #解码需要用到的时间
                        mjd2=$(ymd2mjd $e_iyear $e_imonth $e_iday)
                        YDOY2=($(mjd2ydoy $mjd2))   
                        doy2=${YDOY2[1]}      #下载数据、路劲需要
                        if [ ! -d "$obsdir_p/$e_iyear/$doy2" ];then
                                mkdir "$obsdir_p/$e_iyear/$doy2" -p        #如果是同一天就创建同一个目录两次
                        fi

                        if [ ${s_iday} -eq ${e_iday} ];then
                                obsdir1=$obsdir/$s_iyear/$doy1
                                download_obs_15 ${YMD1} ${s_iyear} ${doy1} "${starttime}" "${endtime}" ${obsdir1} ${sitn1} ${flag}
                                #download one time brdm
                                if [ $num -eq 0 ];then
                                        download_brdm_old ${s_iyear} ${doy1}
                                fi
                        fi
                        if [ ${s_iday} -ne ${e_iday} ];then
                                starttime1="$s_iyear $s_imonth $s_iday $s_ihour $s_iminute $s_isec"
                                endtime1="$s_iyear $s_imonth $s_iday 24 00 00"
                                starttime2="$e_iyear $e_imonth $e_iday 00 00 00"  #分为两个时段
                                endtime2="$e_iyear $e_imonth $e_iday $e_ihour $e_iminute $e_isec"
                                obsdir1=${obsdir}/${s_iyear}/${doy1}
                                obsdir2=${obsdir}/${e_iyear}/${doy2}
                                #echo ${YMD1} ${s_iyear} ${doy1} ${starttime1} ${endtime1} ${obsdir1} ${sitn1}
                                let flag=1
                                download_obs_15 ${YMD1} ${s_iyear} ${doy1} "${starttime1}" "${endtime1}" ${obsdir1} ${sitn1} ${flag}
                                if [ $num -eq 0 ];then
                                        download_brdm_old ${s_iyear} ${doy1}
                                fi
                                let flag=0
                                download_obs_15 ${YMD2} ${e_iyear} ${doy2} "${starttime2}" "${endtime2}" ${obsdir2} ${sitn1} ${flag}
                                if [ $num -eq 0 ];then
                                        download_brdm_old ${e_iyear} ${doy2}
                                fi
                        fi

                fi     
                let num=num+1
        done < ${SITLIST}
        
fi
